---
title: ':empty'
slug: 'Web/CSS/:empty'
tags:
  - CSS
  - Layout
  - NeedsUpdate
  - Pseudo-class
  - Reference
  - Selector
  - Web
---
<div>{{CSSRef}}</div>

<p>The <strong><code>:empty</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Pseudo-classes">pseudo-class</a> represents any element that has no children. Children can be either element nodes or text (including whitespace). Comments, processing instructions, and CSS {{cssxref("content")}} do not affect whether an element is considered empty.</p>

<div class="notecard note">
<p><strong>Note:</strong> In {{SpecName("CSS4 Selectors", "#the-empty-pseudo")}} the <code>:empty</code> pseudo-class was changed to act like <span style="white-space: nowrap;">{{CSSxRef(":-moz-only-whitespace")}}</span>, but no browser currently supports this yet.</p>
</div>

<pre class="brush: css no-line-numbers notranslate">/* Selects any &lt;div&gt; that contains no content */
div:empty {
  background: lime;
}</pre>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">{{CSSSyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;div class="box"&gt;&lt;!-- I will be lime. --&gt;&lt;/div&gt;
&lt;div class="box"&gt;I will be pink.&lt;/div&gt;
&lt;div class="box"&gt;
	&lt;!-- I will be pink in older browsers because of the whitespace around this comment. --&gt;
&lt;/div&gt;
&lt;div class="box"&gt;
	&lt;p&gt;&lt;!-- I will be pink in all browsers because of the non-collapsible whitespace and elements around this comment. --&gt;&lt;/p&gt;
&lt;/div&gt;
</pre>

<h3 id="CSS">CSS</h3>

<div class="hidden">
<pre class="brush: css notranslate">body {
  display: flex;
  justify-content: space-around;
}</pre>
</div>

<pre class="brush: css notranslate">.box {
  background: pink;
  height: 80px;
  width: 80px;
}

.box:empty {
  background: lime;
}</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Examples", 300, 80)}}</p>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>Assistive technology such as screen readers cannot parse interactive content that is empty. All interactive content must have an accessible name, which is created by providing a text value for the interactive control's parent element (<a href="/en-US/docs/Web/HTML/Element/a">anchors</a>, <a href="/en-US/docs/Web/HTML/Element/button">buttons</a>, etc.). Accessible names expose the interactive control to the <a href="/en-US/docs/Learn/Accessibility/What_is_accessibility#Accessibility_APIs">accessibility tree</a>, an API that communicates information useful for assistive technologies.</p>

<p>The text that provides the interactive control's accessible name can be hidden using <a href="https://gomakethings.com/hidden-content-for-better-a11y/#hiding-the-link" rel="noopener">a combination of properties</a> that remove it visually from the screen but keep it parseable by assistive technology. This is commonly used for buttons that rely solely on an icon to convey purpose.</p>

<ul>
 <li><a href="https://developer.paciellogroup.com/blog/2017/04/what-is-an-accessible-name/" rel="noopener">What is an accessible name? | The Paciello Group</a></li>
 <li><a href="https://gomakethings.com/hidden-content-for-better-a11y/">Hidden content for better a11y | Go Make Things</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/Understanding_WCAG/Operable#Guideline_2.4_%E2%80%94_Navigable_Provide_ways_to_help_users_navigate_find_content_and_determine_where_they_are">MDN Understanding WCAG, Guideline 2.4 explanations</a></li>
 <li><a href="https://www.w3.org/TR/UNDERSTANDING-WCAG20/navigation-mechanisms-refs.html">Understanding Success Criterion 2.4.4 | W3C Understanding WCAG 2.0</a></li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS4 Selectors", "#the-empty-pseudo", "the <code>:empty</code> pseudo-class")}}</td>
   <td>{{Spec2("CSS4 Selectors")}}</td>
   <td>Changed to act like {{CSSxRef(":-moz-only-whitespace")}}.</td>
  </tr>
  <tr>
   <td>{{SpecName("CSS3 Selectors", "#empty-pseudo", "the <code>:empty</code> pseudo-class")}}</td>
   <td>{{Spec2("CSS3 Selectors")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.selectors.empty")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{CSSxRef(":-moz-only-whitespace")}} {{Non-standard_Inline}} – The {{glossary("prefix", "prefixed")}} implementation of the changes in {{SpecName("CSS4 Selectors", "#the-empty-pseudo")}}</li>
 <li>{{CSSxRef(":blank")}} {{Experimental_Inline}}</li>
</ul>
